<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Under Water Drone: cuboid.hh Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Under Water Drone
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('cuboid_8hh_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">cuboid.hh</div>  </div>
</div><!--header-->
<div class="contents">
<a href="cuboid_8hh.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;fstream&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="rotation_matrix_8hh.html">rotationMatrix.hh</a>&quot;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="shape_8hh.html">shape.hh</a>&quot;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="class_cuboid.html">   14</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_cuboid.html">Cuboid</a> : <span class="keyword">public</span> <a class="code" href="class_shape.html">Shape</a> {</div>
<div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="class_cuboid.html#a7cecbba106d01150eb52d53bc0b5d15a">   18</a></span>&#160;    <span class="keyword">const</span> std::string <a class="code" href="class_cuboid.html#a7cecbba106d01150eb52d53bc0b5d15a">kModelCuboid_</a> = <span class="stringliteral">&quot;solid/cuboidModel.dat&quot;</span>;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="class_cuboid.html#a0574a7d21a42de91ead1f99857eb10d2">   23</a></span>&#160;    std::vector&lt;Vector3D&gt; <a class="code" href="class_cuboid.html#a0574a7d21a42de91ead1f99857eb10d2">points_</a>;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;  <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="class_cuboid.html#ade7f4821f35a2b32d2b969f30d0ed9be">   29</a></span>&#160;    std::vector&lt;Vector3D&gt; <a class="code" href="class_cuboid.html#ade7f4821f35a2b32d2b969f30d0ed9be">cuboidCover_</a>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_cuboid.html#a8e5ab60bcdf1e2a0571f1d38800543a4">translateCover</a>(<span class="keyword">const</span> <a class="code" href="class_vector.html">Vector3D</a> &amp;change);</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    [[nodiscard]] std::vector&lt;Vector3D&gt; <a class="code" href="class_cuboid.html#a01ff3d2d1f5d2736d614bfe2adf695dd">getNextStepCover</a>(<span class="keyword">const</span> <a class="code" href="class_vector.html">Vector3D</a> &amp;translation) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;  <span class="keyword">public</span>:</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <a class="code" href="class_cuboid.html#a1abf60e93d024b7a01ee5b1a48f1f08a">Cuboid</a>();</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160; </div>
<div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="class_cuboid.html#aba010c63b64540741c25b5e89b7fabbb">   59</a></span>&#160;    <a class="code" href="class_cuboid.html#aba010c63b64540741c25b5e89b7fabbb">~Cuboid</a>() { <a class="code" href="class_shape.html#aa807a43b362e4ef73df68fe95813ec4a">currentCounter_</a> -= <a class="code" href="class_cuboid.html#a0574a7d21a42de91ead1f99857eb10d2">points_</a>.size(); }</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_cuboid.html#ac05b065f9298c6577f8bf4af96ae08a2">draw</a>(<span class="keyword">const</span> std::string &amp;filename) <span class="keyword">const override</span>;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;};</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclass_cuboid_html_aba010c63b64540741c25b5e89b7fabbb"><div class="ttname"><a href="class_cuboid.html#aba010c63b64540741c25b5e89b7fabbb">Cuboid::~Cuboid</a></div><div class="ttdeci">~Cuboid()</div><div class="ttdoc">Destructor for Cuboid class.</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8hh_source.html#l00059">cuboid.hh:59</a></div></div>
<div class="ttc" id="arotation_matrix_8hh_html"><div class="ttname"><a href="rotation_matrix_8hh.html">rotationMatrix.hh</a></div></div>
<div class="ttc" id="aclass_cuboid_html_a8e5ab60bcdf1e2a0571f1d38800543a4"><div class="ttname"><a href="class_cuboid.html#a8e5ab60bcdf1e2a0571f1d38800543a4">Cuboid::translateCover</a></div><div class="ttdeci">void translateCover(const Vector3D &amp;change)</div><div class="ttdoc">Translates the drone cover. Moves the drone cover the same translation vector as the drone body.</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8cpp_source.html#l00052">cuboid.cpp:52</a></div></div>
<div class="ttc" id="ashape_8hh_html"><div class="ttname"><a href="shape_8hh.html">shape.hh</a></div></div>
<div class="ttc" id="aclass_cuboid_html_a7cecbba106d01150eb52d53bc0b5d15a"><div class="ttname"><a href="class_cuboid.html#a7cecbba106d01150eb52d53bc0b5d15a">Cuboid::kModelCuboid_</a></div><div class="ttdeci">const std::string kModelCuboid_</div><div class="ttdoc">File containing the cuboid coordinates model.</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8hh_source.html#l00018">cuboid.hh:18</a></div></div>
<div class="ttc" id="aclass_cuboid_html_ac05b065f9298c6577f8bf4af96ae08a2"><div class="ttname"><a href="class_cuboid.html#ac05b065f9298c6577f8bf4af96ae08a2">Cuboid::draw</a></div><div class="ttdeci">void draw(const std::string &amp;filename) const override</div><div class="ttdoc">Saves the bottom coordinates to a result file.</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8cpp_source.html#l00029">cuboid.cpp:29</a></div></div>
<div class="ttc" id="aclass_shape_html"><div class="ttname"><a href="class_shape.html">Shape</a></div><div class="ttdoc">Models the concept of the geometric object.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00012">shape.hh:12</a></div></div>
<div class="ttc" id="aclass_shape_html_aa807a43b362e4ef73df68fe95813ec4a"><div class="ttname"><a href="class_shape.html#aa807a43b362e4ef73df68fe95813ec4a">Shape::currentCounter_</a></div><div class="ttdeci">static unsigned currentCounter_</div><div class="ttdoc">Number of current Vector3D objects.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00040">shape.hh:40</a></div></div>
<div class="ttc" id="aclass_cuboid_html_a01ff3d2d1f5d2736d614bfe2adf695dd"><div class="ttname"><a href="class_cuboid.html#a01ff3d2d1f5d2736d614bfe2adf695dd">Cuboid::getNextStepCover</a></div><div class="ttdeci">std::vector&lt; Vector3D &gt; getNextStepCover(const Vector3D &amp;translation) const</div><div class="ttdoc">Calculate the coordinates of drone cover in next step of animation (movement)</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8cpp_source.html#l00060">cuboid.cpp:60</a></div></div>
<div class="ttc" id="aclass_vector_html"><div class="ttname"><a href="class_vector.html">Vector&lt; double, 3 &gt;</a></div></div>
<div class="ttc" id="aclass_cuboid_html_a0574a7d21a42de91ead1f99857eb10d2"><div class="ttname"><a href="class_cuboid.html#a0574a7d21a42de91ead1f99857eb10d2">Cuboid::points_</a></div><div class="ttdeci">std::vector&lt; Vector3D &gt; points_</div><div class="ttdoc">Set of cuboid coordinates.</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8hh_source.html#l00023">cuboid.hh:23</a></div></div>
<div class="ttc" id="aclass_cuboid_html_a1abf60e93d024b7a01ee5b1a48f1f08a"><div class="ttname"><a href="class_cuboid.html#a1abf60e93d024b7a01ee5b1a48f1f08a">Cuboid::Cuboid</a></div><div class="ttdeci">Cuboid()</div><div class="ttdoc">Constructor for Cuboid class.</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8cpp_source.html#l00005">cuboid.cpp:5</a></div></div>
<div class="ttc" id="aclass_cuboid_html_ade7f4821f35a2b32d2b969f30d0ed9be"><div class="ttname"><a href="class_cuboid.html#ade7f4821f35a2b32d2b969f30d0ed9be">Cuboid::cuboidCover_</a></div><div class="ttdeci">std::vector&lt; Vector3D &gt; cuboidCover_</div><div class="ttdoc">Set of drone cover coordinates used in checkCollision functions.</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8hh_source.html#l00029">cuboid.hh:29</a></div></div>
<div class="ttc" id="aclass_cuboid_html"><div class="ttname"><a href="class_cuboid.html">Cuboid</a></div><div class="ttdoc">Models the concept of the cuboid.</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8hh_source.html#l00014">cuboid.hh:14</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_167790342fb55959539d550b874be046.html">project</a></li><li class="navelem"><a class="el" href="dir_0e6a83f483eb86bac30676662de98147.html">inc</a></li><li class="navelem"><a class="el" href="cuboid_8hh.html">cuboid.hh</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
